## rsplib 3.5.1

=== CMakeLists.txt ===
# --------------------------------------------------------------------------
#
#              //===//   //=====   //===//   //       //   //===//
#             //    //  //        //    //  //       //   //    //
#            //===//   //=====   //===//   //       //   //===<<
#           //   \\         //  //        //       //   //    //
#          //     \\  =====//  //        //=====  //   //===//   Version III
#
# ------------- An Efficient RSerPool Prototype Implementation -------------
#
# Copyright (C) 2002-2025 by Thomas Dreibholz
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# Contact: thomas.dreibholz@gmail.com

CMAKE_MINIMUM_REQUIRED(VERSION 3.5)
PROJECT(rsplib LANGUAGES C CXX)

SET(BUILD_MAJOR "3")
SET(BUILD_MINOR "5")
SET(BUILD_PATCH "1")
SET(BUILD_VERSION ${BUILD_MAJOR}.${BUILD_MINOR}.${BUILD_PATCH})


#############################################################################
#### INSTALLATION_DIRECTORIES                                            ####
#############################################################################

# See: https://cmake.org/cmake/help/v3.0/module/GNUInstallDirs.html
INCLUDE(GNUInstallDirs)


#############################################################################
#### PACKAGING                                                           ####
#############################################################################

SET(CPACK_SOURCE_GENERATOR "TXZ")
SET(CPACK_SOURCE_PACKAGE_FILE_NAME
    "${CMAKE_PROJECT_NAME}-${BUILD_MAJOR}.${BUILD_MINOR}.${BUILD_PATCH}")
SET(CPACK_SOURCE_IGNORE_FILES "\\\\.git;\\\\.swp$;~$;\\\\.\\\\#;/\\\\#")
LIST(APPEND CPACK_SOURCE_IGNORE_FILES "^${PROJECT_SOURCE_DIR}/${CMAKE_PROJECT_NAME}[_-]")
LIST(APPEND CPACK_SOURCE_IGNORE_FILES "\\\\.cmake$|\\\\.make$|\\\\.log$")
LIST(APPEND CPACK_SOURCE_IGNORE_FILES "/CMakeCache\\\\.txt$")
LIST(APPEND CPACK_SOURCE_IGNORE_FILES "/(CMakeFiles|CMakeScripts|_CPack_Packages)/")
LIST(APPEND CPACK_SOURCE_IGNORE_FILES "/package-version\\\\.h$")
LIST(APPEND CPACK_SOURCE_IGNORE_FILES "/packaging\\\\.conf$")
LIST(APPEND CPACK_SOURCE_IGNORE_FILES "^${PROJECT_SOURCE_DIR}/(po.*/|src.*/|)Makefile$")
INCLUDE(CPack)

ADD_CUSTOM_TARGET(dist COMMAND ${CMAKE_MAKE_PROGRAM} clean package_source)


#############################################################################
#### UNINSTALL                                                           ####
#############################################################################

IF(NOT TARGET uninstall)
   CONFIGURE_FILE(
      "${CMAKE_CURRENT_SOURCE_DIR}/cmake_uninstall.cmake.in"
      "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
      IMMEDIATE @ONLY)

   ADD_CUSTOM_TARGET(uninstall
      COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake)
ENDIF()


#############################################################################
#### OS-DEPENDENT                                                        ####
#############################################################################

IF (${CMAKE_SYSTEM_NAME} MATCHES "Linux")
   MESSAGE(STATUS ${CMAKE_SYSTEM_NAME} " supported")
   ADD_DEFINITIONS("-D_DEFAULT_SOURCE")

ELSEIF (${CMAKE_SYSTEM_NAME} MATCHES "FreeBSD")
   MESSAGE(STATUS ${CMAKE_SYSTEM_NAME} " supported")
   SET(CMAKE_REQUIRED_INCLUDES "/usr/local/include" "/usr/include")
   SET(CMAKE_LIBRARY_PATH "/usr/local/lib")
   INCLUDE_DIRECTORIES("/usr/local/include")
   SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -pthread")
   SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -pthread")

ELSEIF (${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
   MESSAGE(STATUS ${CMAKE_SYSTEM_NAME} " supported")
   SET(CMAKE_REQUIRED_INCLUDES "/usr/local/include" "/usr/include" "/usr/local/opt/openssl/include")
   SET(CMAKE_LIBRARY_PATH "/usr/local/lib")
   INCLUDE_DIRECTORIES("/usr/local/include" "/usr/local/opt/openssl/include")

ELSEIF (${CMAKE_SYSTEM_NAME} MATCHES "NetBSD")
   MESSAGE(STATUS ${CMAKE_SYSTEM_NAME} " supported")
   SET(CMAKE_REQUIRED_INCLUDES "/usr/pkg/include" "/usr/include" "/usr/local/include")
   SET(CMAKE_LIBRARY_PATH "/usr/local/lib")
   INCLUDE_DIRECTORIES("/usr/pkg/include" "/usr/local/include")

ELSE()
   MESSAGE(FATAL_ERROR ${CMAKE_SYSTEM_NAME} " not supported (yet?)")

ENDIF()


#############################################################################
#### CHECK STRUCT MEMBERS                                                ####
#############################################################################

INCLUDE(CheckIncludeFile)
INCLUDE(CheckStructHasMember)

CHECK_STRUCT_HAS_MEMBER("struct sockaddr" "sa_len" "sys/types.h;sys/socket.h" HAVE_SA_LEN)
IF (HAVE_SA_LEN)
   MESSAGE(STATUS "HAVE_SA_LEN")
   ADD_DEFINITIONS(-DHAVE_SA_LEN)
ENDIF()

CHECK_STRUCT_HAS_MEMBER("struct sockaddr_in" "sin_len" "sys/types.h;netinet/in.h" HAVE_SIN_LEN)
IF (HAVE_SIN_LEN)
   MESSAGE(STATUS "HAVE_SIN_LEN")
   ADD_DEFINITIONS(-DHAVE_SIN_LEN)
ENDIF()

CHECK_STRUCT_HAS_MEMBER("struct sockaddr_in6" "sin6_len" "sys/types.h;netinet/in.h" HAVE_SIN6_LEN)
IF (HAVE_SIN6_LEN)
   MESSAGE(STATUS "HAVE_SIN6_LEN")
   ADD_DEFINITIONS(-DHAVE_SIN6_LEN)
ENDIF()

CHECK_STRUCT_HAS_MEMBER("struct sockaddr_storage" "ss_len" "sys/types.h;sys/socket.h" HAVE_SS_LEN)
IF (HAVE_SS_LEN)
   MESSAGE(STATUS "HAVE_SS_LEN")
   ADD_DEFINITIONS(-DHAVE_SS_LEN)
ENDIF()


#############################################################################
#### CHECK OPTIONS                                                       ####
#############################################################################

# Maximum logging level
SET(MAX_LOGLEVEL "9" CACHE STRING "Maximum logging level")
ADD_DEFINITIONS(-DMAX_LOGLEVEL=${MAX_LOGLEVEL})

# Registrar statistics
OPTION(ENABLE_REGISTRAR_STATISTICS "Enable Registrar statistics" 1)
IF (ENABLE_REGISTRAR_STATISTICS)
   ADD_DEFINITIONS(-DENABLE_REGISTRAR_STATISTICS)
ENDIF()

# Handlespace Management verification
OPTION(ENABLE_HSMGTVERIFY   "Enable handlespace management verification" 0)
IF(ENABLE_HSMGTVERIFY)
   ADD_DEFINITIONS(-DVERIFY)
ENDIF()

# Registrar statistics
OPTION(ENABLE_CSP           "Enable CSP" 1)
IF (ENABLE_CSP)
   ADD_DEFINITIONS(-DENABLE_CSP)
ENDIF()

# Qt programs
OPTION(ENABLE_QT            "Include Qt programs" 1)

# # KDE programs
# OPTION(ENABLE_KDE          "Include KDE programs" 0)

# Kernel SCTP
OPTION(USE_KERNEL_SCTP      "Use Kernel SCTP" 1)

# Test programs
OPTION(ENABLE_TEST_PROGRAMS "Build test programs" 0)

# Icons and logo files
OPTION(ENABLE_ICONS         "Build RSPLIB icons and logo files" 1)


# Handlespace management storage implementation
ADD_DEFINITIONS(-DINCLUDE_SIMPLEREDBLACKTREE -DUSE_SIMPLEREDBLACKTREE)


#############################################################################
#### REQUIREMENTS                                                        ####
#############################################################################

# ====== Valgrind ===========================================================
CHECK_INCLUDE_FILE("valgrind/memcheck.h" HAVE_VALGRIND_MEMCHECK_H)
IF(HAVE_VALGRIND_MEMCHECK_H)
   ADD_DEFINITIONS(-DHAVE_VALGRIND_MEMCHECK_H)
ENDIF()


# ====== Threads ============================================================
FIND_PACKAGE(Threads REQUIRED)


# ====== Qt =================================================================
IF (ENABLE_QT OR ENABLE_KDE)
   SET(CMAKE_AUTOMOC ON)
   FIND_PACKAGE(QT NAMES Qt6 COMPONENTS Core Network Widgets Xml)
   IF (NOT QT_FOUND)
      FIND_PACKAGE(QT NAMES Qt5 REQUIRED COMPONENTS Core Network Widgets Xml)
   ENDIF()
   MESSAGE("Using Qt version ${QT_VERSION_MAJOR}!")
   FIND_PACKAGE(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Core Network Widgets Xml)
ENDIF()


# # ====== KDE ================================================================
# IF (ENABLE_KDE)
#    # Needed:
#    # KDE5: libkf5coreaddons-dev libkf5xmlgui-dev
#    # KDE6: libkf6coreaddons-dev libkf6xmlgui-dev
#
#    FIND_PACKAGE(ECM "1.0.0" NO_MODULE REQUIRED)
#    SET(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${ECM_MODULE_PATH} ${ECM_KDE_MODULE_DIR})
#
#    INCLUDE(KDEInstallDirs)
#    INCLUDE(KDECMakeSettings)
#    INCLUDE(KDECompilerSettings NO_POLICY_SCOPE)
#    INCLUDE(KDEFrameworkCompilerSettings NO_POLICY_SCOPE)
#
#    FIND_PACKAGE(KF${QT_VERSION_MAJOR} "${QT_VERSION_MAJOR}.0.0" REQUIRED COMPONENTS CoreAddons WidgetsAddons)
# ENDIF()


# ====== SCTP ==============================================================#
IF (USE_KERNEL_SCTP)
   # ====== Kernel SCTP =====================================================
   CHECK_INCLUDE_FILE(netinet/sctp.h HAVE_NETINET_SCTP_H)
   IF (HAVE_NETINET_SCTP_H)
      SET(SCTP_INCLUDE "netinet/sctp.h")
      ADD_DEFINITIONS(-DHAVE_KERNEL_SCTP -DHAVE_NETINET_SCTP_H)
      IF (${CMAKE_SYSTEM_NAME} MATCHES "Linux")
         FIND_LIBRARY(SCTP_LIB sctp REQUIRED)
      ELSE()
         FIND_LIBRARY(SCTP_LIB sctp)
      ENDIF()
      IF (SCTP_LIB)
         SET(CMAKE_REQUIRED_LIBRARIES ${CMAKE_REQUIRED_LIBRARIES} ${SCTP_LIB})
      ELSE()
         SET(SCTP_LIB "")
      ENDIF()
   ENDIF()

ELSE()
   # ====== SCTPLIB User-Space SCTP =========================================
   CHECK_INCLUDE_FILE(sctp.h HAVE_SCTPLIB_SCTP_H)
   FIND_LIBRARY(SCTPLIB_LIB sctplib)
   IF (NOT HAVE_SCTPLIB_SCTP_H OR NOT SCTPLIB_LIB)
      MESSAGE(FATAL_ERROR "sctplib not found - libsctplib installed?")
   ENDIF()
   MESSAGE(STATUS "sctplib found: ${SCTPLIB_LIB}")

   CHECK_INCLUDE_FILE(sctp.h HAVE_SCTPSOCKET_SCTP_H)
   FIND_LIBRARY(SCTPSOCKET_LIB sctpsocket)
   IF (NOT HAVE_SCTPSOCKET_SCTP_H OR NOT SCTPSOCKET_LIB)
      MESSAGE(FATAL_ERROR "sctpsocket not found - libsctpsocket installed?")
   ENDIF()
   MESSAGE(STATUS "sctpsocket found: ${SCTPSOCKET_LIB}")

   FIND_PACKAGE(PkgConfig)
   PKG_CHECK_MODULES(GLIB glib-2.0)
   IF (NOT ${GLIB_LIBS})
      MESSAGE(FATAL_ERROR "glib not found - glib-2.0 installed?")
   ENDIF()
   MESSAGE(STATUS "glib found: ${GLIB_LIBRARIES}")

   SET(SCTP_LIB ${SCTPSOCKET_LIB} ${SCTPLIB_LIB} ${GLIB_LIBRARIES})
   SET(CMAKE_REQUIRED_LIBRARIES ${CMAKE_REQUIRED_LIBRARIES} ${SCTPSOCKET_LIB} ${SCTPLIB_LIB} ${GLIB_LIBRARIES})
ENDIF()


# ====== Graphics tools for icons and logo ==================================
IF (ENABLE_ICONS)
   FIND_PROGRAM(GS gs PATHS /bin /usr/bin /usr/local/bin)
   IF(NOT GS)
      MESSAGE(FATAL_ERROR
            " Cannot find GhostScript! Try:\n"
            " * Ubuntu/Debian: sudo apt install -y ghostscript\n"
            " * Fedora:        sudo dnf install -y ghostscript\n"
            " * FreeBSD:       sudo pkg install -y ghostscript10")
   ENDIF()

   FIND_PROGRAM(PDF2SVG pdf2svg PATHS /bin /usr/bin /usr/local/bin)
   IF(NOT PDF2SVG)
      MESSAGE(FATAL_ERROR
            " Cannot find PDF2SVG! Try:\n"
            " * Ubuntu/Debian: sudo apt install -y pdf2svg\n"
            " * Fedora:        sudo dnf install -y pdf2svg\n"
            " * FreeBSD:       sudo pkg install -y pdf2svg")
   ENDIF()

   FIND_PROGRAM(GM gm PATHS /bin /usr/bin /usr/local/bin)
   IF(NOT GM)
      MESSAGE(FATAL_ERROR
            " Cannot find GraphicsMagick! Try:\n"
            " * Ubuntu/Debian: sudo apt install -y graphicsmagick\n"
            " * Fedora:        sudo dnf install -y GraphicsMagick\n"
            " * FreeBSD:       sudo pkg install -y GraphicsMagick")
   ENDIF()
ENDIF()


# ====== Functions ==========================================================
INCLUDE(CheckFunctionExists)
INCLUDE(CheckSymbolExists)

=== docs/Makefile ===
# CMAKE generated file: DO NOT EDIT!
# Generated by "Unix Makefiles" Generator, CMake Version 3.28

# Default target executed when no arguments are given to make.
default_target: all
.PHONY : default_target

# Allow only one "make -f Makefile2" at a time, but pass parallelism.
.NOTPARALLEL:

#=============================================================================
# Special targets provided by cmake.

# Disable implicit rules so canonical targets will work.
.SUFFIXES:

# Disable VCS-based implicit rules.
% : %,v

# Disable VCS-based implicit rules.
% : RCS/%

# Disable VCS-based implicit rules.
% : RCS/%,v

# Disable VCS-based implicit rules.
% : SCCS/s.%

# Disable VCS-based implicit rules.
% : s.%

.SUFFIXES: .hpux_make_needs_suffix_list

# Command-line flag to silence nested $(MAKE).
$(VERBOSE)MAKESILENT = -s

#Suppress display of executed commands.
$(VERBOSE).SILENT:

# A target that is always out of date.
cmake_force:
.PHONY : cmake_force

#=============================================================================
# Set environment variables for the build.

# The shell in which to execute make rules.
SHELL = /bin/sh

# The CMake executable.
CMAKE_COMMAND = /usr/bin/cmake

# The command to remove a file.
RM = /usr/bin/cmake -E rm -f

# Escaping for special characters.
EQUALS = =

# The top-level source directory on which CMake was run.
CMAKE_SOURCE_DIR = /home/dreibh/src/rsplib

# The top-level build directory on which CMake was run.
CMAKE_BINARY_DIR = /home/dreibh/src/rsplib

#=============================================================================
# Targets provided globally by CMake.

# Special rule for the target package
package: preinstall
	@$(CMAKE_COMMAND) -E cmake_echo_color "--switch=$(COLOR)" --cyan "Run CPack packaging tool..."
	cd /home/dreibh/src/rsplib && /usr/bin/cpack --config ./CPackConfig.cmake
.PHONY : package

# Special rule for the target package
package/fast: package
.PHONY : package/fast

# Special rule for the target package_source
package_source:
	@$(CMAKE_COMMAND) -E cmake_echo_color "--switch=$(COLOR)" --cyan "Run CPack packaging tool for source..."
	cd /home/dreibh/src/rsplib && /usr/bin/cpack --config ./CPackSourceConfig.cmake /home/dreibh/src/rsplib/CPackSourceConfig.cmake
.PHONY : package_source

# Special rule for the target package_source
package_source/fast: package_source
.PHONY : package_source/fast

# Special rule for the target edit_cache
edit_cache:
	@$(CMAKE_COMMAND) -E cmake_echo_color "--switch=$(COLOR)" --cyan "Running CMake cache editor..."
	/usr/bin/ccmake -S$(CMAKE_SOURCE_DIR) -B$(CMAKE_BINARY_DIR)
.PHONY : edit_cache

# Special rule for the target edit_cache
edit_cache/fast: edit_cache
.PHONY : edit_cache/fast

# Special rule for the target rebuild_cache
rebuild_cache:
	@$(CMAKE_COMMAND) -E cmake_echo_color "--switch=$(COLOR)" --cyan "Running CMake to regenerate build system..."
	/usr/bin/cmake --regenerate-during-build -S$(CMAKE_SOURCE_DIR) -B$(CMAKE_BINARY_DIR)
.PHONY : rebuild_cache

# Special rule for the target rebuild_cache
rebuild_cache/fast: rebuild_cache
.PHONY : rebuild_cache/fast

# Special rule for the target list_install_components
list_install_components:
	@$(CMAKE_COMMAND) -E cmake_echo_color "--switch=$(COLOR)" --cyan "Available install components are: \"Unspecified\""
.PHONY : list_install_components

# Special rule for the target list_install_components
list_install_components/fast: list_install_components
.PHONY : list_install_components/fast

# Special rule for the target install
install: preinstall
	@$(CMAKE_COMMAND) -E cmake_echo_color "--switch=$(COLOR)" --cyan "Install the project..."
	/usr/bin/cmake -P cmake_install.cmake
.PHONY : install

# Special rule for the target install
install/fast: preinstall/fast
	@$(CMAKE_COMMAND) -E cmake_echo_color "--switch=$(COLOR)" --cyan "Install the project..."
	/usr/bin/cmake -P cmake_install.cmake
.PHONY : install/fast

# Special rule for the target install/local
install/local: preinstall
	@$(CMAKE_COMMAND) -E cmake_echo_color "--switch=$(COLOR)" --cyan "Installing only the local directory..."
	/usr/bin/cmake -DCMAKE_INSTALL_LOCAL_ONLY=1 -P cmake_install.cmake
.PHONY : install/local

# Special rule for the target install/local
install/local/fast: preinstall/fast
	@$(CMAKE_COMMAND) -E cmake_echo_color "--switch=$(COLOR)" --cyan "Installing only the local directory..."
	/usr/bin/cmake -DCMAKE_INSTALL_LOCAL_ONLY=1 -P cmake_install.cmake
.PHONY : install/local/fast

# Special rule for the target install/strip
install/strip: preinstall
	@$(CMAKE_COMMAND) -E cmake_echo_color "--switch=$(COLOR)" --cyan "Installing the project stripped..."
	/usr/bin/cmake -DCMAKE_INSTALL_DO_STRIP=1 -P cmake_install.cmake
.PHONY : install/strip

# Special rule for the target install/strip
install/strip/fast: preinstall/fast
	@$(CMAKE_COMMAND) -E cmake_echo_color "--switch=$(COLOR)" --cyan "Installing the project stripped..."
	/usr/bin/cmake -DCMAKE_INSTALL_DO_STRIP=1 -P cmake_install.cmake
.PHONY : install/strip/fast

# The main all target
all: cmake_check_build_system
	cd /home/dreibh/src/rsplib && $(CMAKE_COMMAND) -E cmake_progress_start /home/dreibh/src/rsplib/CMakeFiles /home/dreibh/src/rsplib/docs//CMakeFiles/progress.marks
	cd /home/dreibh/src/rsplib && $(MAKE) $(MAKESILENT) -f CMakeFiles/Makefile2 docs/all
	$(CMAKE_COMMAND) -E cmake_progress_start /home/dreibh/src/rsplib/CMakeFiles 0
.PHONY : all

# The main clean target
clean:
	cd /home/dreibh/src/rsplib && $(MAKE) $(MAKESILENT) -f CMakeFiles/Makefile2 docs/clean
.PHONY : clean

# The main clean target
clean/fast: clean
.PHONY : clean/fast

# Prepare targets for installation.
preinstall: all
	cd /home/dreibh/src/rsplib && $(MAKE) $(MAKESILENT) -f CMakeFiles/Makefile2 docs/preinstall
.PHONY : preinstall

# Prepare targets for installation.
preinstall/fast:
	cd /home/dreibh/src/rsplib && $(MAKE) $(MAKESILENT) -f CMakeFiles/Makefile2 docs/preinstall
.PHONY : preinstall/fast

# clear depends
depend:
	cd /home/dreibh/src/rsplib && $(CMAKE_COMMAND) -S$(CMAKE_SOURCE_DIR) -B$(CMAKE_BINARY_DIR) --check-build-system CMakeFiles/Makefile.cmake 1
.PHONY : depend

# Help Target
help:
	@echo "The following are some of the valid targets for this Makefile:"
	@echo "... all (the default if no target is provided)"
	@echo "... clean"
	@echo "... depend"
	@echo "... edit_cache"
	@echo "... install"
	@echo "... install/local"
	@echo "... install/strip"
	@echo "... list_install_components"
	@echo "... package"
	@echo "... package_source"
	@echo "... rebuild_cache"
.PHONY : help



#=============================================================================
# Special targets to cleanup operation of make.

# Special rule to run CMake to check the build system integrity.
# No rule that depends on this can have commands that come from listfiles
# because they might be regenerated.
cmake_check_build_system:
	cd /home/dreibh/src/rsplib && $(CMAKE_COMMAND) -S$(CMAKE_SOURCE_DIR) -B$(CMAKE_BINARY_DIR) --check-build-system CMakeFiles/Makefile.cmake 0
.PHONY : cmake_check_build_system

=== src/CMakeLists.txt ===
# --------------------------------------------------------------------------
#
#              //===//   //=====   //===//   //       //   //===//
#             //    //  //        //    //  //       //   //    //
#            //===//   //=====   //===//   //       //   //===<<
#           //   \\         //  //        //       //   //    //
#          //     \\  =====//  //        //=====  //   //===//   Version III
#
# ------------- An Efficient RSerPool Prototype Implementation -------------
#
# Copyright (C) 2002-2025 by Thomas Dreibholz
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# Contact: thomas.dreibholz@gmail.com


SET(CMAKE_INCLUDE_CURRENT_DIR ON)

#############################################################################
#### LIBRARIES                                                           ####
#############################################################################

# ====== liblibtdtimeutilities ==============================================
LIST(APPEND libtdtimeutilities_headers
   timeutilities.h
)
LIST(APPEND libtdtimeutilities_sources
   timeutilities.c
)

INSTALL(FILES ${libtdtimeutilities_headers} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/rserpool)

ADD_LIBRARY(libtdtimeutilities-shared SHARED ${libtdtimeutilities_sources})
ADD_LIBRARY(libtdtimeutilities-static STATIC ${libtdtimeutilities_sources})
FOREACH(TYPE shared;static)
   SET_TARGET_PROPERTIES(libtdtimeutilities-${TYPE} PROPERTIES OUTPUT_NAME tdtimeutilities CLEAN_DIRECT_OUTPUT 1)
   SET_TARGET_PROPERTIES(libtdtimeutilities-${TYPE} PROPERTIES
      VERSION   ${BUILD_VERSION}
      SOVERSION ${BUILD_MAJOR}
   )
   TARGET_LINK_LIBRARIES (libtdtimeutilities-${TYPE} ${SCTP_LIB} "${CMAKE_THREAD_LIBS_INIT}" m)
   INSTALL(TARGETS libtdtimeutilities-${TYPE} DESTINATION ${CMAKE_INSTALL_LIBDIR})
ENDFOREACH()


# ====== liblibtdrandomizer =================================================
LIST(APPEND libtdrandomizer_headers
   randomizer.h
)
LIST(APPEND libtdrandomizer_sources
   randomizer.c
)

INSTALL(FILES ${libtdrandomizer_headers} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/rserpool)

ADD_LIBRARY(libtdrandomizer-shared SHARED ${libtdrandomizer_sources})
ADD_LIBRARY(libtdrandomizer-static STATIC ${libtdrandomizer_sources})
FOREACH(TYPE shared;static)
   SET_TARGET_PROPERTIES(libtdrandomizer-${TYPE} PROPERTIES OUTPUT_NAME tdrandomizer CLEAN_DIRECT_OUTPUT 1)
   SET_TARGET_PROPERTIES(libtdrandomizer-${TYPE} PROPERTIES
      VERSION   ${BUILD_VERSION}
      SOVERSION ${BUILD_MAJOR}
   )
   TARGET_LINK_LIBRARIES (libtdrandomizer-${TYPE} libtdtimeutilities-${TYPE} ${SCTP_LIB} "${CMAKE_THREAD_LIBS_INIT}")
   INSTALL(TARGETS libtdrandomizer-${TYPE} DESTINATION ${CMAKE_INSTALL_LIBDIR})
ENDFOREACH()


# ====== liblibtdstringutilities ============================================
LIST(APPEND libtdstringutilities_headers
   stringutilities.h
)
LIST(APPEND libtdstringutilities_sources
   stringutilities.c
)

INSTALL(FILES ${libtdstringutilities_headers} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/rserpool)

ADD_LIBRARY(libtdstringutilities-shared SHARED ${libtdstringutilities_sources})
ADD_LIBRARY(libtdstringutilities-static STATIC ${libtdstringutilities_sources})
FOREACH(TYPE shared;static)
   SET_TARGET_PROPERTIES(libtdstringutilities-${TYPE} PROPERTIES OUTPUT_NAME tdstringutilities CLEAN_DIRECT_OUTPUT 1)
   SET_TARGET_PROPERTIES(libtdstringutilities-${TYPE} PROPERTIES
      VERSION   ${BUILD_VERSION}
      SOVERSION ${BUILD_MAJOR}
   )
   TARGET_LINK_LIBRARIES (libtdstringutilities-${TYPE} ${SCTP_LIB} "${CMAKE_THREAD_LIBS_INIT}")
   INSTALL(TARGETS libtdstringutilities-${TYPE} DESTINATION ${CMAKE_INSTALL_LIBDIR})
ENDFOREACH()


# ====== libtdthreadsafety ======================================================
LIST(APPEND libtdthreadsafety_headers
   threadsafety.h threadsignal.h
)
LIST(APPEND libtdthreadsafety_sources
   threadsafety.c threadsignal.c
)

INSTALL(FILES ${libtdthreadsafety_headers} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/rserpool)

ADD_LIBRARY(libtdthreadsafety-shared SHARED ${libtdthreadsafety_sources})
ADD_LIBRARY(libtdthreadsafety-static STATIC ${libtdthreadsafety_sources})
FOREACH(TYPE shared;static)
   SET_TARGET_PROPERTIES(libtdthreadsafety-${TYPE} PROPERTIES OUTPUT_NAME tdthreadsafety CLEAN_DIRECT_OUTPUT 1)
   SET_TARGET_PROPERTIES(libtdthreadsafety-${TYPE} PROPERTIES
      VERSION   ${BUILD_VERSION}
      SOVERSION ${BUILD_MAJOR}
   )
   TARGET_LINK_LIBRARIES (libtdthreadsafety-${TYPE} ${SCTP_LIB} "${CMAKE_THREAD_LIBS_INIT}")
   INSTALL(TARGETS libtdthreadsafety-${TYPE} DESTINATION ${CMAKE_INSTALL_LIBDIR})
ENDFOREACH()


# ====== libtdloglevel ======================================================
LIST(APPEND libtdloglevel_headers
   loglevel.h
)
LIST(APPEND libtdloglevel_sources
   loglevel.c
)

INSTALL(FILES ${libtdloglevel_headers} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/rserpool)

ADD_LIBRARY(libtdloglevel-shared SHARED ${libtdloglevel_sources})
ADD_LIBRARY(libtdloglevel-static STATIC ${libtdloglevel_sources})
FOREACH(TYPE shared;static)
   SET_TARGET_PROPERTIES(libtdloglevel-${TYPE} PROPERTIES OUTPUT_NAME tdloglevel CLEAN_DIRECT_OUTPUT 1)
   SET_TARGET_PROPERTIES(libtdloglevel-${TYPE} PROPERTIES
      VERSION   ${BUILD_VERSION}
      SOVERSION ${BUILD_MAJOR}
   )
   TARGET_LINK_LIBRARIES (libtdloglevel-${TYPE} libtdtimeutilities-${TYPE} libtdthreadsafety-${TYPE} ${SCTP_LIB} "${CMAKE_THREAD_LIBS_INIT}")
   INSTALL(TARGETS libtdloglevel-${TYPE} DESTINATION ${CMAKE_INSTALL_LIBDIR})
ENDFOREACH()


# ====== libtdtagitem =======================================================
LIST(APPEND libtdtagitem_headers
   tagitem.h
)
LIST(APPEND libtdtagitem_sources
   tagitem.c
)

INSTALL(FILES ${libtdtagitem_headers} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/rserpool)

ADD_LIBRARY(libtdtagitem-shared SHARED ${libtdtagitem_sources})
ADD_LIBRARY(libtdtagitem-static STATIC ${libtdtagitem_sources})
FOREACH(TYPE shared;static)
   SET_TARGET_PROPERTIES(libtdtagitem-${TYPE} PROPERTIES OUTPUT_NAME tdtagitem CLEAN_DIRECT_OUTPUT 1)
   SET_TARGET_PROPERTIES(libtdtagitem-${TYPE} PROPERTIES
      VERSION   ${BUILD_VERSION}
      SOVERSION ${BUILD_MAJOR}
   )
   TARGET_LINK_LIBRARIES (libtdtagitem-${TYPE} libtdloglevel-${TYPE} ${SCTP_LIB} "${CMAKE_THREAD_LIBS_INIT}")
   INSTALL(TARGETS libtdtagitem-${TYPE} DESTINATION ${CMAKE_INSTALL_LIBDIR})
ENDFOREACH()


# ====== libtdbreakdetector =================================================
LIST(APPEND libtdbreakdetector_headers
   breakdetector.h
)
LIST(APPEND libtdbreakdetector_sources
   breakdetector.c
)

INSTALL(FILES ${libtdbreakdetector_headers} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/rserpool)

ADD_LIBRARY(libtdbreakdetector-shared SHARED ${libtdbreakdetector_sources})
ADD_LIBRARY(libtdbreakdetector-static STATIC ${libtdbreakdetector_sources})
FOREACH(TYPE shared;static)
   SET_TARGET_PROPERTIES(libtdbreakdetector-${TYPE} PROPERTIES OUTPUT_NAME tdbreakdetector CLEAN_DIRECT_OUTPUT 1)
   SET_TARGET_PROPERTIES(libtdbreakdetector-${TYPE} PROPERTIES
      VERSION   ${BUILD_VERSION}
      SOVERSION ${BUILD_MAJOR}
   )
   TARGET_LINK_LIBRARIES (libtdbreakdetector-${TYPE} libtdtimeutilities-${TYPE} ${SCTP_LIB} ${ATOMIC_LIB} "${CMAKE_THREAD_LIBS_INIT}")
   INSTALL(TARGETS libtdbreakdetector-${TYPE} DESTINATION ${CMAKE_INSTALL_LIBDIR})
ENDFOREACH()


# ====== libtdcppthread =====================================================
LIST(APPEND libtdcppthread_headers
   mutex.h thread.h
)
LIST(APPEND libtdcppthread_sources
   mutex.cc thread.cc
)

INSTALL(FILES ${libtdcppthread_headers} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/rserpool)

ADD_LIBRARY(libtdcppthread-shared SHARED ${libtdcppthread_sources})
ADD_LIBRARY(libtdcppthread-static STATIC ${libtdcppthread_sources})
FOREACH(TYPE shared;static)
   SET_TARGET_PROPERTIES(libtdcppthread-${TYPE} PROPERTIES OUTPUT_NAME tdcppthread CLEAN_DIRECT_OUTPUT 1)
   SET_TARGET_PROPERTIES(libtdcppthread-${TYPE} PROPERTIES
      VERSION   ${BUILD_VERSION}
      SOVERSION ${BUILD_MAJOR}
   )
   TARGET_LINK_LIBRARIES (libtdcppthread-${TYPE} libtdthreadsafety-${TYPE} ${SCTP_LIB} "${CMAKE_THREAD_LIBS_INIT}")
   INSTALL(TARGETS libtdcppthread-${TYPE} DESTINATION ${CMAKE_INSTALL_LIBDIR})
ENDFOREACH()


# ====== libtdstorage =====================================================
LIST(APPEND libtdstorage_headers
   doublelinkedringlist.h
   leaflinkedredblacktree.h
   redblacktree.h
   redblacktree_impl.h
   simpleredblacktree.h
)
LIST(APPEND libtdstorage_sources
   doublelinkedringlist.c
   leaflinkedredblacktree.c
   simpleredblacktree.c
)

INSTALL(FILES ${libtdstorage_headers} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/rserpool)

ADD_LIBRARY(libtdstorage-shared SHARED ${libtdstorage_sources})
ADD_LIBRARY(libtdstorage-static STATIC ${libtdstorage_sources})
FOREACH(TYPE shared;static)
   SET_TARGET_PROPERTIES(libtdstorage-${TYPE} PROPERTIES OUTPUT_NAME tdstorage CLEAN_DIRECT_OUTPUT 1)
   SET_TARGET_PROPERTIES(libtdstorage-${TYPE} PROPERTIES
      VERSION   ${BUILD_VERSION}
      SOVERSION ${BUILD_MAJOR}
   )
   TARGET_LINK_LIBRARIES (libtdstorage-${TYPE} ${SCTP_LIB} "${CMAKE_THREAD_LIBS_INIT}")
   INSTALL(TARGETS libtdstorage-${TYPE} DESTINATION ${CMAKE_INSTALL_LIBDIR})
ENDFOREACH()


# ====== libtdnetutilities ==================================================
LIST(APPEND libtdnetutilities_headers
   ext_socket.h
   messagebuffer.h
   netutilities.h
   netdouble.h
   sockaddrunion.h
)
LIST(APPEND libtdnetutilities_sources
   messagebuffer.c
   netutilities.c
   netdouble.c
)

INSTALL(FILES ${libtdnetutilities_headers} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/rserpool)

ADD_LIBRARY(libtdnetutilities-shared SHARED ${libtdnetutilities_sources})
ADD_LIBRARY(libtdnetutilities-static STATIC ${libtdnetutilities_sources})
FOREACH(TYPE shared;static)
   SET_TARGET_PROPERTIES(libtdnetutilities-${TYPE} PROPERTIES OUTPUT_NAME tdnetutilities CLEAN_DIRECT_OUTPUT 1)
   SET_TARGET_PROPERTIES(libtdnetutilities-${TYPE} PROPERTIES
      VERSION   ${BUILD_VERSION}
      SOVERSION ${BUILD_MAJOR}
   )
TARGET_LINK_LIBRARIES (libtdnetutilities-${TYPE} libtdrandomizer-${TYPE} libtdstringutilities-${TYPE} libtdtimeutilities-${TYPE} libtdloglevel-${TYPE} ${SCTP_LIB} "${CMAKE_THREAD_LIBS_INIT}")
   INSTALL(TARGETS libtdnetutilities-${TYPE} DESTINATION ${CMAKE_INSTALL_LIBDIR})
ENDFOREACH()


# ====== librsphsmgt ========================================================
LIST(APPEND librsphsmgt_headers
   rserpoolerror.h
   poolhandlespacechecksum.h
   peerlistmanagement-template.h
   peerlistmanagement-template_impl.h
   peerlistnode-template.h
   peerlistnode-template_impl.h
   peerlist-template.h
   peerlist-template_impl.h
   poolelementnode-template.h
   poolelementnode-template_impl.h
   poolhandle.h
   poolhandlespacemanagement-basics.h
   poolhandlespacemanagement.h
   poolhandlespacemanagement-template.h
   poolhandlespacemanagement-template_impl.h
   poolhandlespacenode-template.h
   poolhandlespacenode-template_impl.h
   poolnode-template.h
   poolnode-template_impl.h
   poolpolicysettings.h
   poolpolicy-template.h
   poolpolicy-template_impl.h
   pooluserlist-template.h
   pooluserlist-template_impl.h
   poolusernode-template.h
   poolusernode-template_impl.h
   timestamphashtable.h
   transportaddressblock.h
)
LIST(APPEND librsphsmgt_sources
   rserpoolerror.c
   poolhandlespacechecksum.c
   poolhandle.c
   poolhandlespacemanagement-basics.c
   poolhandlespacemanagement.c

=== freebsd/rsplib/Makefile ===
PORTNAME=	rsplib
DISTVERSION=	3.5.1
CATEGORIES=	net
MASTER_SITES=	https://www.nntb.no/~dreibh/rserpool/download/

MAINTAINER=	thomas.dreibholz@gmail.com
COMMENT=	RSerPool Framework and Example Applications
WWW=		https://www.nntb.no/~dreibh/rserpool/

LICENSE=	GPLv3+
LICENSE_FILE=	${WRKSRC}/COPYING

USES=		cmake qt:6 shebangfix tar:xz
SHEBANG_FILES=	src/scriptingserviceexample
USE_LDCONFIG=	yes
USE_QT=		base

PLIST_SUB=	DISTVERSION=${DISTVERSION}

CMAKE_ARGS=	-DCMAKE_INSTALL_DOCDIR=${DOCSDIR} \
		-DUSE_KERNEL_SCTP=1 -DENABLE_CSP=1 -DENABLE_QT=1

.include <bsd.port.mk>

=== src/logo/CMakeLists.txt ===
# --------------------------------------------------------------------------
#
#              //===//   //=====   //===//   //       //   //===//
#             //    //  //        //    //  //       //   //    //
#            //===//   //=====   //===//   //       //   //===<<
#           //   \\         //  //        //       //   //    //
#          //     \\  =====//  //        //=====  //   //===//   Version III
#
# ------------- An Efficient RSerPool Prototype Implementation -------------
#
# Copyright (C) 2002-2025 by Thomas Dreibholz
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# Contact: thomas.dreibholz@gmail.com

#############################################################################
#### LOGO                                                                ####
#############################################################################

SET(LOGO "rsplib")

# To check the system's icon sizes available:
# find /usr/share/icons/hicolor/ -maxdepth 1 -type d -printf "%f\n" | grep -E "^[0-9]+" | sort | cut -dx -f1 | sort -n
SET(ICON_LENGTHS
   8
   16
   20
   22
   24
   32
   36
   40
   42
   44
   48
   64
   72
   96
   128
   150
   192
   256
   310
   512
)
SET(LOGO_LENGTH 1920)

IF (ENABLE_ICONS)
   FOREACH(iconLength IN ITEMS ${ICON_LENGTHS};${LOGO_LENGTH})
   # PNG with fixed width, height as necessary:
   ADD_CUSTOM_COMMAND(OUTPUT  ${CMAKE_CURRENT_BINARY_DIR}/${LOGO}-${iconLength}x.png
                      COMMAND ${GS} -dNOSAFER -dQUIET -dBATCH -dNOPAUSE -dNOPROMPT -dEPSCrop -dAlignToPixels=0 -dGridFitTT=2 -sDEVICE=pngalpha -r${iconLength}x -sOUTPUTFILE="${CMAKE_CURRENT_BINARY_DIR}/${LOGO}-${iconLength}x.png" "${CMAKE_CURRENT_SOURCE_DIR}/${LOGO}.pdf")
   ADD_CUSTOM_TARGET(generate_${LOGO}_${iconLength}x_png ALL DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/${LOGO}-${iconLength}x.png)

   # PNG with fixed, same width and height:
   IF(NOT ${iconLength} STREQUAL "1920")
      ADD_CUSTOM_COMMAND(OUTPUT  ${CMAKE_CURRENT_BINARY_DIR}/${LOGO}-${iconLength}x${iconLength}.png
                         COMMAND ${GM} convert ${LOGO}-${iconLength}x.png -resize ${iconLength}x -background none -gravity center -extent ${iconLength}x${iconLength} ${LOGO}-${iconLength}x${iconLength}.png
                         DEPENDS generate_${LOGO}_${iconLength}x_png
                                 ${CMAKE_CURRENT_BINARY_DIR}/${LOGO}-${iconLength}x.png)
      ADD_CUSTOM_TARGET(generate_${LOGO}_${iconLength}x${iconLength}_png ALL DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/${LOGO}-${iconLength}x${iconLength}.png)

      # PNG icon of dimension ${iconLength}x${iconLength}:
      INSTALL(FILES       ${CMAKE_CURRENT_BINARY_DIR}/${LOGO}-${iconLength}x${iconLength}.png
              DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/${iconLength}x${iconLength}/apps
              RENAME      ${LOGO}.png)
   ENDIF()
   ENDFOREACH()

   # A high-resolution logo PNG file:
   INSTALL(FILES       ${CMAKE_CURRENT_BINARY_DIR}/${LOGO}-${LOGO_LENGTH}x.png
           DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/rsplib
           RENAME      ${LOGO}.png)

   # Scalable logo PDF file:
   INSTALL(FILES ${LOGO}.pdf DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/rsplib)

   # Scalable SVG icon:
   ADD_CUSTOM_COMMAND(OUTPUT  ${CMAKE_CURRENT_BINARY_DIR}/${LOGO}.svg
                      COMMAND ${PDF2SVG} ${CMAKE_CURRENT_SOURCE_DIR}/${LOGO}.pdf ${LOGO}.svg)
   ADD_CUSTOM_TARGET(generate_${LOGO}_svg ALL DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/${LOGO}.svg)
   INSTALL(FILES       ${CMAKE_CURRENT_BINARY_DIR}/${LOGO}.svg
           DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/scalable/apps)
ENDIF()

=== debian/changelog ===
rsplib (3.5.1-1.3) unstable; urgency=medium

  * Non-maintainer upload.
  * Backport upstream fix for FTBFS with GCC 15. (Closes: #1114349)

 -- Adrian Bunk <bunk@debian.org>  Wed, 08 Oct 2025 17:23:12 +0300

rsplib (3.5.1-1.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Add Breaks/Replaces on separated-out rsplib-fractalpooluser (Closes: #1100891).

 -- Bastian Germann <bage@debian.org>  Tue, 20 May 2025 08:48:49 +0200

rsplib (3.5.1-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Source-only reupload to let the package rebuild on a buildd node.

 -- Bastian Germann <bage@debian.org>  Wed, 19 Mar 2025 23:38:26 +0100

rsplib (3.5.1-1) unstable; urgency=low

  * New upstream release.
  * debian/librsplib3.symbols: Added missing symbol.
  * debian/control: Fixed Multi-Arch settings.
  * debian/control: Updated standards version to 4.7.0.
  * debian/control: Removed unnecessary build dependencies.
  * debian/control: Fixed dependency on obsolete lsb-core.
  * debian/control: Removed unnecessary constraints.

 -- Thomas Dreibholz <thomas.dreibholz@gmail.com>  Mon, 17 Feb 2025 21:45:08 +0100

=== debian/control ===
Source: rsplib
Section: net
Priority: optional
Maintainer: Thomas Dreibholz <thomas.dreibholz@gmail.com>
Homepage: https://www.nntb.no/~dreibh/rserpool/
Vcs-Git: https://github.com/dreibh/rsplib.git
Vcs-Browser: https://github.com/dreibh/rsplib
Build-Depends: cmake,
               debhelper-compat (= 13),
               dpkg-dev (>= 1.22.5),
               ghostscript,
               graphicsmagick,
               libbz2-dev,
               libgl-dev,
               libsctp-dev,
               pdf2svg,
               qt6-base-dev
Standards-Version: 4.7.1
Rules-Requires-Root: no

Package: librsplib3t64
Provides: ${t64:Provides}
Replaces: librsplib3
Breaks: librsplib3 (<< ${source:Version})
Section: libs
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: RSerPool client/server API library for session management
 Reliable Server Pooling (RSerPool) is the IETF's standard (RFC 5351 to
 RFC 5356) for a lightweight server pool and session management framework.
 It provides highly available pool management (that is registration
 handling and load distribution/balancing) by components called Registrar
 and a client-side/server-side API for accessing the service of a pool.
 .
 The API library is provided by this package.

Package: librsplib-dev
Section: libdevel
Architecture: any
Depends: librsplib3t64 (= ${binary:Version}),
         ${misc:Depends}
Recommends: rsplib-doc (>= ${source:Version})
Description: headers of the RSerPool client/server API library rsplib
 Reliable Server Pooling (RSerPool) is the IETF's standard (RFC 5351 to
 RFC 5356) for a lightweight server pool and session management framework.
 It provides highly available pool management (that is registration
 handling and load distribution/balancing) by components called Registrar
 and a client-side/server-side API for accessing the service of a pool.
 .
 This package provides header files for the rsplib library. You need them
 to develop your own RSerPool-based clients and servers.

Package: libcpprspserver3t64
Provides: ${t64:Provides}
Replaces: libcpprspserver3
Breaks: libcpprspserver3 (<< ${source:Version})
Section: libs
Architecture: any
Depends: librsplib3t64 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: C++ RSerPool client/server API library
 Reliable Server Pooling (RSerPool) is the IETF's standard (RFC 5351 to
 RFC 5356) for a lightweight server pool and session management framework.
 It provides highly available pool management (that is registration
 handling and load distribution/balancing) by components called Registrar
 and a client-side/server-side API for accessing the service of a pool.
 .
 This package provides an object-oriented API for the rsplib library.

Package: libcpprspserver-dev
Section: libdevel
Architecture: any
Depends: libcpprspserver3t64 (= ${binary:Version}),
         librsplib-dev (>= ${source:Version}),
         ${misc:Depends}
Recommends: rsplib-doc (>= ${source:Version})
Description: headers of the C++ RSerPool client/server API library
 Reliable Server Pooling (RSerPool) is the IETF's standard (RFC 5351 to
 RFC 5356) for a lightweight server pool and session management framework.
 It provides highly available pool management (that is registration
 handling and load distribution/balancing) by components called Registrar
 and a client-side/server-side API for accessing the service of a pool.
 .
 This package provides the header files for the rsplib C++ API. You need them to
 develop your own RSerPool-based clients and servers based on the C++ API.

Package: rsplib-doc
Provides: rsplib-docs
Replaces: rsplib-docs
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Recommends: rsplib-tools
Description: documentation of the RSerPool implementation RSPLIB
 Reliable Server Pooling (RSerPool) is the IETF's standard (RFC 5351 to
 RFC 5356) for a lightweight server pool and session management framework.
 It provides highly available pool management (that is registration
 handling and load distribution/balancing) by components called Registrar
 and a client-side/server-side API for accessing the service of a pool.
 .
 This package contains the documentation for the RSerPool implementation
 RSPLIB.

Package: rsplib-registrar
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Recommends: rsplib-doc (>= ${source:Version})
Description: RSerPool Registrar service
 Reliable Server Pooling (RSerPool) is the IETF's standard (RFC 5351 to
 RFC 5356) for a lightweight server pool and session management framework.
 It provides highly available pool management (that is registration
 handling and load distribution/balancing) by components called Registrar
 and a client-side/server-side API for accessing the service of a pool.
 .
 This package provides the registrar, which is the management component
 for RSerPool-based server pools. You need at least one registrar in a
 setup, but for redundancy reasons, you should have at least two.

Package: rsplib-tools
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Recommends: chrpath,
            rsplib-doc (>= ${source:Version})
Description: RSerPool test tools
 Reliable Server Pooling (RSerPool) is the IETF's standard (RFC 5351 to
 RFC 5356) for a lightweight server pool and session management framework.
 It provides highly available pool management (that is registration
 handling and load distribution/balancing) by components called Registrar
 and a client-side/server-side API for accessing the service of a pool.
 .
 This package provides some test tools for RSerPool setups.

Package: rsplib-services
Architecture: any
Depends: rsplib-common (>= ${source:Version}),
         rsplib-tools (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: rsplib-doc (>= ${source:Version})
Suggests: rsplib-fractalpooluser
Description: RSerPool example services
 Reliable Server Pooling (RSerPool) is the IETF's standard (RFC 5351 to
 RFC 5356) for a lightweight server pool and session management framework.
 It provides highly available pool management (that is registration
 handling and load distribution/balancing) by components called Registrar
 and a client-side/server-side API for accessing the service of a pool.
 .
 This package provides the rsplib RSerPool example services:
 Echo, Discard, Daytime, CharGen, CalcApp, and ScriptingService.

Package: rsplib-fractalpooluser
Architecture: any
Replaces: rsplib-services (<< 3.5.1)
Breaks: rsplib-services (<< 3.5.1)
Depends: rsplib-common (>= ${source:Version}),
         rsplib-tools (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: rsplib-doc (>= ${source:Version}),
            rsplib-services (= ${binary:Version})
Description: RSerPool-based fractal generator client
 Reliable Server Pooling (RSerPool) is the IETF's standard (RFC 5351 to
 RFC 5356) for a lightweight server pool and session management framework.
 It provides highly available pool management (that is registration
 handling and load distribution/balancing) by components called Registrar
 and a client-side/server-side API for accessing the service of a pool.
 .
 This package provides the provides the Pool User client for the
 FractalGenerator service. Is uses a Qt-based GUI.

Package: rsplib-common
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Recommends: rsplib-tools
Provides: rsplib-fgp-cfgfiles
Replaces: rsplib-fgp-cfgfiles
Breaks: rsplib-fgp-cfgfiles (<< ${source:Version})
Description: RSerPool Fractal Generator Service example input files
 Reliable Server Pooling (RSerPool) is the IETF's standard (RFC 5351 to
 RFC 5356) for a lightweight server pool and session management framework.
 It provides highly available pool management (that is registration
 handling and load distribution/balancing) by components called Registrar
 and a client-side/server-side API for accessing the service of a pool.
 .
 This package provides common files for the example service.

Package: rsplib-all
Architecture: any
Depends: libcpprspserver-dev (>= ${source:Version}),
         libcpprspserver3t64 (= ${binary:Version}),
         librsplib-dev (>= ${source:Version}),
         librsplib3t64 (= ${binary:Version}),
         rsplib-common (>= ${source:Version}),
         rsplib-doc (>= ${source:Version}),
         rsplib-fractalpooluser (= ${binary:Version}),
         rsplib-registrar (= ${binary:Version}),
         rsplib-services (= ${binary:Version}),
         rsplib-tools (= ${binary:Version}),
         ${misc:Depends}
Description: RSerPool implementation RSPLIB
 Reliable Server Pooling (RSerPool) is the IETF's standard (RFC 5351 to
 RFC 5356) for a lightweight server pool and session management framework.
 It provides highly available pool management (that is registration
 handling and load distribution/balancing) by components called Registrar
 and a client-side/server-side API for accessing the service of a pool.
 .
 This is the installation metapackage for the RSerPool implementation RSPLIB.
 It installs all RSPLIB components.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -- -DUSE_KERNEL_SCTP=ON -DENABLE_CSP=ON -DENABLE_QT=ON -DENABLE_ICONS=ON

override_dh_installchangelogs:
	dh_installchangelogs -k ChangeLog

=== debian/watch ===
version=4
opts=pgpsigurlmangle=s/$/.asc/ \
https://www.nntb.no/~dreibh/rserpool/  download/rsplib-(.*)\.tar\.xz

## rsplib 3.5.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -30,7 +30,7 @@
 
 SET(BUILD_MAJOR "3")
 SET(BUILD_MINOR "5")
-SET(BUILD_PATCH "1")
+SET(BUILD_PATCH "2")
 SET(BUILD_VERSION ${BUILD_MAJOR}.${BUILD_MINOR}.${BUILD_PATCH})

=== freebsd/rsplib/Makefile ===
PORTNAME=	rsplib
DISTVERSION=	3.5.2
PORTREVISION=	2
CATEGORIES=	net
MASTER_SITES=	https://www.nntb.no/~dreibh/rserpool/download/

MAINTAINER=	thomas.dreibholz@gmail.com
COMMENT=	RSerPool Framework and Example Applications
WWW=		https://www.nntb.no/~dreibh/rserpool/

LICENSE=	GPLv3+
LICENSE_FILE=	${WRKSRC}/COPYING

BUILD_DEPENDS=	gm:graphics/GraphicsMagick \
		pdf2svg:graphics/pdf2svg

USES=		cmake desktop-file-utils ghostscript:10,build gl qt:6 \
		shebangfix tar:xz
USE_GL=		gl opengl
USE_LDCONFIG=	yes
USE_QT=		base

SHEBANG_FILES=	src/scriptingserviceexample

CMAKE_ARGS=	-DCMAKE_INSTALL_DOCDIR=${DOCSDIR} \
		-DENABLE_CSP=1 \
		-DENABLE_QT=1 \
		-DUSE_KERNEL_SCTP=1

# Work-around for build issue #285706 on ARM (https://bugs.freebsd.org/bugzilla/show_bug.cgi?id=285706):
MAKE_ENV=       OMP_NUM_THREADS=1

PLIST_SUB=	DISTVERSION=${DISTVERSION}

.include <bsd.port.mk>
